<script lang="ts">
  import { eventId, keycloak, team } from '@stores';
  import type { ActiveChallenge } from '@models/Challenges';
  import { Gql } from '@db';
  import { Badge, Card, CardBody, CardHeader, Input, InputGroup, InputGroupText, Label } from '@sveltestrap/sveltestrap';
  import type { NullableEventRole } from '@auth/models';
  import { EventRole } from '@auth/models';
  import ChallengeModal from '@components/Challenges/ChallengeModal.svelte';
  import { onMount } from 'svelte';

  let hideUnreleased = false;
  let challenges: ActiveChallenge[] = [];
  let categories: Array<string>;
  let challengeModal: ChallengeModal;
  let queryRole: NullableEventRole = $keycloak?.getFirstRole([
    EventRole.CTFAdmin,
    EventRole.Staff,
    EventRole.Participant,
  ]);

  $: if (challenges) categories = [...new Set(challenges.map((c) => c.challenge!.category))];
  $: console.log(challenges);

  onMount(setupSubscription);

  function setupSubscription() {
    const solvesQuery = `
        solves(where: {team_id: {_eq: ${JSON.stringify($team?.id)}}}) {
          challenge_id
          time
          team_id
        }`;
    const query = `subscription {
      challenges_active (
        where: {event_id: {_eq: ${JSON.stringify($eventId)}}},
        order_by: {challenge: {name: asc}, points: desc}
      ) {
        points
        release_time
        released
        event_id
        challenge_id
        event {
          id
          name
          start
          end
        }
        files {
          file_id
          event_id
          file {
            id
            name
            size
            mimeType
          }
        }
        challenge {
          category
          description
          designer
          id
          name
        }
        ${$team ? solvesQuery : ''}
      }
    }`;
    Gql.subscribeSimple<{ challenges_active: ActiveChallenge[] }>(
      query,
      (data) => (challenges = data.challenges_active),
      { role: queryRole },
    );
  }
</script>

<ChallengeModal bind:this={challengeModal} bind:queryRole size="lg" />

{#if $keycloak.isRole(EventRole.Staff)}
  <Input class="clickable" bind:checked={hideUnreleased} type="switch" label="Hide Unreleased" />
{/if}

{#if challenges?.length > 0 && categories?.length > 0}
  {#each categories as challengeCategory}
    <h2 class="category-header mt-3">{challengeCategory}</h2>
    <div class="row row-cols-xs-1 row-cols-sm-2 row-cols-md-3 row-cols-xxl-5">
      {#each challenges as challenge}
        {#if challenge.challenge.category === challengeCategory && (challenge.released || !hideUnreleased)}
          <div class="col p-2">
            <Card class="h-100 clickable" on:click={() => challengeModal.show(challenge)}>
              <CardHeader class="text-center text-white {challenge.solves?.length > 0 ? 'bg-success' : 'bg-secondary'}">
                <p class="fs-3">
                  {challenge.challenge.name}
                </p>
                {#if !challenge.released}
                  <!-- Staff may view challenges not yet released -->
                  <small><Badge pill color="warning">Unreleased</Badge></small>
                {/if}
                <br />
                {#if challenge.challenge.designer}
                  <small class="fs-6">
                    by: {challenge.challenge.designer}
                  </small>
                {/if}
              </CardHeader>
              <CardBody>
                <h3 class="d-flex align-content-center justify-content-center text-white">
                  {challenge.points}
                </h3>
              </CardBody>
            </Card>
          </div>
        {/if}
      {/each}
    </div>
  {/each}
{/if}

<style>
  .category-header {
    border-bottom: 1px solid var(--bs-light);
  }
</style>
